REBOL [
	Title: "REBOL/View Desktop - Goto Window"
	Version: 1.0.0
	Author: "Carl Sassenrath"
	Rights: "Copyright REBOL Technologies 1999-2003"
	Tabs: "Tabspace is 4. PLEASE KEEP IT THAT WAY."
	License: {
		This software is the property of REBOL Technologies and is
		licensed to you under the terms of the REBOL/View Desktop
		License (included in this distribution).
	}
]

goto-url: func [url [url!] /local page script] [
	; Go to a specified URL, try to read it and check to see if it
	; is a valid folder (index file). If it is, show it, otherwise
	; run it.
	url: copy url
	if not page: read-binary url none [
		if ".r" <> to-string find url ".r" [url: append dirize url "index.r"]
		page: read-binary url none
	]
	either page [
		page: to-string page
		either script? page [
			either not error? try [script: load/all page][
				either index-file? script [show-folder url][launch-thru url]
			][
				alert reform ["Invalid REBOL URL:" url]
			]
		][
			browse url
		]
	][
		alert reform ["Cannot find:" url]
	]
]

goto-view: has [gt-url gt-list gtface h enter-url urls result][
	; Popup a requestor to ask for a URL to goto.
	if error? try [urls: load history-file][urls: []]
	gt-face: center-face layout [
		style button button 80
		space 6x4
		h4 bold "Goto a URL (REBOL or Web):"
		across
		gt-url: field 300 [enter-url value]
		button "Goto" [if result: enter-url gt-url/text [unview goto-url result]]
		return
		gt-list: text-list 300x200 data urls [enter-url value]
		h: at
		below at h
		guide
		pad 120
		button "Sort" [sort gt-list/data show gt-list]
		button "Clear All" [attempt [delete history-file] unview]
		button "Close" escape [unview]
	]

	enter-url: func [url /local val] [
		url: copy url
		if not url? url [
			if error? try [val: load/all url  val: val/1][val: none]
			if not url? :val [
				insert url http://
				if error? try [val: load/all url val: val/1][val: none]
			]
			if not url? :val [alert "Invalid URL." return none]
			url: val
		]
		insert clear gt-url/text url
		remove find gt-list/data url
		insert gt-list/data url
		clear gt-list/picked
		show [gt-url gt-list]
		save history-file gt-list/data
		url
	]

	focus gt-url
	view/new/title gt-face "Goto a URL"
]

