REBOL [
	Title: "REBOL/View Desktop - File Initialization"
	Version: 1.0.0
	Author: "Carl Sassenrath"
	Rights: "Copyright REBOL Technologies 1999-2003"
	Tabs: "Tabspace is 4. PLEASE KEEP IT THAT WAY."
	License: {
		This software is the property of REBOL Technologies and is
		licensed to you under the terms of the REBOL/View Desktop
		License (included in this distribution).
	}
]

init-desktop-files: has [paths path files] [
	; Create default desktop files if they are missing:

	history-file: view-root/desktop/history.r
	prefs-file: view-root/desktop/prefs.r

	paths: [
		%desktop/
		%local/
		%desktop/icons/
		%desktop/skins/
		%desktop/sounds/
		%desktop/tools/
	]

	foreach path paths [if not exists? view-root/:path [make-dir/deep view-root/:path]]

	if not exists? path: view-root/desktop/filetypes.r [
		write path join {REBOL [Title: "File Types"]^/} mold/only suffix-map
	]

	files: [
		%desktop/bookmarks.r {
			REBOL [Title: "Bookmarks" Type: 'index]

			folder "REBOL.com" http://www.rebol.com/index.r
			folder "Local" %local/index.r
			file "Console" console icon console
		}
		%desktop/services.r {
			REBOL [Title: "Services" Type: 'index]

			service "Goto" goto
			service "Help" help
			service "Quit" quit
		}
		%local/index.r {
			REBOL [Title: "Local Index" Type: 'index]

			title "Local Files"

			file "Info" %info.txt
		}
		%local/info.txt {
			Local scripts can be placed in this folder. To do so, edit
			your local/index.r file to include the filenames for the
			files that you want to include. You can right click on the
			local folder icon to edit or reload it.
		}
	]
	foreach [file text] files [
		if not exists? path: view-root/:file [write path trim/auto text]
	]
	if not exists? history-file [
		save history-file [
			http://www.rebol.com/index.r
			http://www.rebol.com/index.html
		]
	]
]

